// file      : xsd-frontend/semantic-graph/any.cxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#include <xsd-frontend/semantic-graph/any.hxx>

namespace XSDFrontend
{
  namespace SemanticGraph
  {
    namespace RTTI = Cult::RTTI;

    using RTTI::Access;
    using RTTI::TypeInfo;

    namespace
    {
      struct AnyInit
      {
        AnyInit ()
        {
          TypeInfo ti (typeid (Any));
          ti.add_base (Access::public_, true, typeid (Nameable));
          RTTI::insert (ti);
        }

      } any_init_;
    }

    Any::
    Any (Path const& file,
         UnsignedLong line,
         UnsignedLong column,
         UnsignedLong min,
         UnsignedLong max,
         WideString const& namespaces)
        : Node (file, line, column),
          min_ (min),
          max_ (max)
    {
      // Not sure if the separator is just space or any white-space
      // chararcter.
      //

      for (Size i (0), j (namespaces.find (L' '));;)
      {
        if (j != WideString::npos)
        {
          namespaces_.push_back (WideString (namespaces, i, j - i));

          i = j + 1;
          j = namespaces.find (L' ', i);
        }
        else
        {
          // Last element.
          //
          namespaces_.push_back (WideString (namespaces, i));
          break;
        }
      }
    }
  }
}
